   %MACRO check_var_list_in_tbl(tbl_name_in=, num_vars=, char_vars=)  ;

   /*
	%LET DEBUG_FLAG2=N;

   %check_var_list_in_tbl(tbl_name_in=DATA_IN.LINEAR_KARR_2005
                                       , num_vars=&dependent_vars.  &independent_vars &freq. &weight. ) ;
	   %PUT missing_vars=&missing_vars.;

    %check_var_list_in_tbl(tbl_name_in=DATA_IN.LINEAR_KARR_2005(DROP=&dependent_vars.)
                                       , num_vars=&dependent_vars.  &independent_vars &freq. &weight,char_vars=test) ;
	  %PUT missing_vars=&missing_vars.;
   */

  %GLOBAL m_return_cd m_return_msg missing_vars  DEBUG_FLAG2 ;	
 
 %LOCAL _DEBUG_OPTIONS_L _tmp;

 
 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));
	
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN NONOTES NOSOURCE NOSOURCE2; %END;

 %PUT;
  %PUT -----   Start of the macro check_var_list_in_tbl;
  %PUT;

 %LET m_return_cd=0; 
 %LET m_return_msg=;
  %LET missing_vars=;

   /* This intermediate step is necessary when tbl_name_in has keep or drop options */

PROC DATASETS MEMTYPE=ALL NOLIST NOWARN; DELETE _tmp; RUN; QUIT;
			
	  DATA 	 _tmp/VIEW=_tmp;
		  SET 	&tbl_name_in.;
	   RUN;

  %IF &syserr. NE 0   %THEN 
			%DO; 
	 %LET m_return_cd=1; 
	 %LET m_return_msg=ERROR: &syserrortext.;
  %GOTO endmac; 
     %END;

   	 DATA _NULL_;
	  LENGTH varname varname_ds $ 32 vartype vartype_ds $ 1 missing_vars $ 32000;
		
	   all_vars="&num_vars. &char_vars.";
	   count_n=countw("&num_vars.");
	   count_c=countw("&char_vars.");
	   count_a=count_n+count_c;

		dsid=OPEN("_tmp");
        count_ds_vars=ATTRN(dsid, "NVARS");

				 DO i=1 TO count_a;	

				  IF (i<=count_n) THEN 	vartype="N";
				  ELSE 							 vartype="C";

					 varname=lowcase(SCAN(all_vars,i));
					 found_flag=0;

					   DO j=1 to count_ds_vars;

		                 varname_ds=lowcase(VARNAME(dsid,j));
						 vartype_ds=UPCASE(VARTYPE(dsid,j));

				  		IF  varname=varname_ds AND vartype=vartype_ds
		          		THEN 	found_flag=1;
					  END;

				    IF  found_flag=0 THEN missing_vars=CATX(" ",missing_vars, varname);

				 END;

		  rc=CLOSE(dsid);

		  CALL SYMPUT( "m_return_msg",SYSMSG() );
		  CALL SYMPUT("missing_vars",STRIP(missing_vars));
	RUN;

%IF m_return_cd NE 0 %THEN %LET m_return_cd=&syserr.;
	
  PROC DATASETS MEMTYPE=ALL  NOLIST NOWARN; DELETE _tmp; RUN; QUIT;

  %endmac:

  %IF &m_return_cd. NE 0 %THEN
        %DO;
  %PUT m_return_cd=&m_return_cd. ; 
  %PUT &m_return_msg. ; 
        %END;

 %PUT;
  %PUT -----   End of the macro check_var_list_in_tbl;
  %PUT;

  OPTIONS &_DEBUG_OPTIONS_L.;
   %MEND;