 %MACRO import_dlm_txt_to_sas(file_name_in=
                                                       ,tbl_name_out=
                                                      ,File_type=CSV
													  ,delimiter=
                                                      ,Col_in_fst_row=Y
													  ,guessingrows=32767
													  ,termstr=
													  )	;

	/*
   Usage:

	%LET msoc_lib=msoc1;
   %LET msoc_dir=&msoc1;
   %LET prefix=dr2_i1_;


 %import_dlm_txt_to_sas(file_name_in=&msoc_dir.&prefix.tr_tb_updt.csv
                                      ,tbl_name_out=tr_tb_updt_t
										)	;

%import_dlm_txt_to_sas(file_name_in=&msoc_dir.&prefix.tr_tb_updt_t.txt
                                      ,tbl_name_out=tr_tb_updt_t
									  ,File_type=dlm
									  ,delimiter="&"
                                      ,Col_in_fst_row=Y
										)	;

*/

	%GLOBAL m_return_cd   DEBUG_FLAG2 ;	
 
 %LOCAL _DEBUG_OPTIONS_L str_delimiter str_getnames str_termstr 
                  file_nm_is_fileref tmp_file_name_in;

 %LET m_return_cd=0;

 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));
	
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN NONOTES NOSOURCE NOSOURCE2; %END;

  %PUT;
   %PUT -----   Start of the macro import_dlm_txt_to_sas. ;
   %PUT;

   %IF  %EVAL(%LENGTH(&file_name_in.) -8) >0      %THEN %LET file_nm_is_fileref=0 ;
   %ELSE %IF %sysfunc(fileref(&file_name_in.)) > 0 	%THEN %LET file_nm_is_fileref=0 ;
   %ELSE																					 %LET file_nm_is_fileref=1;

   %IF %LENGTH(&File_type.)=0 %THEN %LET File_type=dlm;
   %IF %LENGTH(&delimiter.)=0           %THEN %LET delimiter=" ";

   %IF %lowcase(&File_type.)=dlm %THEN %LET str_delimiter=%STR(DELIMITER=&delimiter.);
   %ELSE %LET str_delimiter=;

    %IF %lowcase(&File_type.) NE jmp %THEN %LET str_getnames=%STR(getnames=&Col_in_fst_row.);
   %ELSE %LET str_getnames=;

     %IF %LENGTH(&termstr.)=0 AND &file_nm_is_fileref.=0 %THEN 
                         %DO;	  
  DATA _NULL_;
  INFILE  "&file_name_in."   RECFM=N  /*LRECL=300  OBS=1*/  EOF=end_of_file_label;
    INPUT str $1. @@;
    LENGTH  prev_str $ 1 termstr $ 4;
	 RETAIN prev_str  ;

  IF             str="0A"x          AND prev_str="0D"x               THEN termstr="CRLF";  /* WIN */
  ELSE 	IF str="0A"x                                                           THEN termstr="LF";	   /*Linux, UNIX */
  ELSE IF  prev_str="0D"x    		                                       THEN termstr="CR"; 	 /* MAC */

  IF  termstr NE " "  THEN
				  DO;
    	/*	PUT prev_str $HEX2. str  $HEX2. termstr @@;	*/
		CALL SYMPUT("termstr",STRIP(termstr)) ;
end_of_file_label:	  
                STOP;
	             END;

	   prev_str=str;
RUN;

						 %END;

 %IF 	&file_nm_is_fileref.=0 %THEN 
                                    %DO;

 %IF %LENGTH(&termstr.)>0 %THEN  %LET str_termstr=%STR(TERMSTR=&termstr.);
 %ELSE %LET str_termstr=;

   FILENAME _tmpf  "&file_name_in." LRECL=32767  &str_termstr.;

                   %LET tmp_file_name_in=_tmpf;
			                        %END;
   %ELSE 	%LET tmp_file_name_in=&file_name_in.;			 

 PROC IMPORT DATAFILE=&tmp_file_name_in.  REPLACE
     OUT=&tbl_name_out.
     DBMS=&File_type.
   ;
	 &str_delimiter.; 
	 &str_getnames.;
	 GUESSINGROWS=&guessingrows. ;
RUN;

%LET m_return_cd=&syserr.;

%IF &file_nm_is_fileref.=0 %THEN  FILENAME _tmpf  CLEAR ;;

%IF &m_return_cd. NE 0 %THEN
        %DO;
  %PUT m_return_cd=&m_return_cd. ;  
        %END;

		%IF &DEBUG_FLAG2. = Y %THEN
		            %DO;
			%PUT file_nm_is_fileref=&file_nm_is_fileref.;
			%PUT tmp_file_name_in=&tmp_file_name_in.;
			%PUT File_type=&File_type.;
			%PUT str_delimiter=&str_delimiter.;
			%PUT str_getnames=&str_getnames.;
			%PUT guessingrows=&guessingrows.;
			%PUT str_termstr=&str_termstr;	  
			        %END;

  %PUT;
   %PUT -----   End of the macro import_dlm_txt_to_sas.  ;
   %PUT;

  OPTIONS &_DEBUG_OPTIONS_L.;
%MEND;
 