%MACRO logit_reg_with_data_input(tbl_name_in= 
															   ,dependent_vars=
															   ,independent_vars=
															   ,freq=
															   ,weight=
															   ,NOINT=
															   ,prefix=cl1_
															   ,alpha=0.05
															   ,lib_out=DPLocal
															  ,groups=10
															  ,xconv=1e-4
															  ,max_iter_nb=10
																) ;

   %LOCAL freq_c freq2 weight_c weight2 _cl lib_out0 str_Select ;

   
   /*
	%LET reg_ds_in=DATA_IN.LINEAR_KARR_2005;
   *	%LET  dependent_vars=medv;
	%LET  dependent_vars=medv_high_flag;
	%LET intercept=intercept;
	%LET independent_vars=crim indus dis dummy_dp_var2 dummy_dp_var3;
*	%LET independent_vars=crim indus dis;
	%LET groups=10;
	%LET alpha=0.05;
	%LET max_iter_nb=10	;
	%LET XCONV=1e-4	 ;
   	%LET lib_out=DPLocal.;
   */
	/*
    %LET prefix_c=CL1_;
	%LET freq=;
	%LET weight=;
	 */

    %LET  weight_c=;	
    %LET  freq_c=;

	 %LET  freq2=1;
	 %LET  weight2=1;
  
 /*
	%LET prefix_c=CL1W2_;
	%LET weight=WEIGHT2;
   */

   /*
	 %LET prefix_c=CL1W3_;
	%LET weight=WEIGHT3;   * scale by 2 all observation.
   */
  
	 %IF  %LENGTH(&lib_out.) >0  AND  %INDEX(&lib_out.,.) =0 %THEN 	 %LET  lib_out=&lib_out.%STR(.);


%IF %UPCASE(&NOINT.)=NOINT	%THEN  %LET Intercept=;
%ELSE  %LET Intercept=Intercept;

 %IF  %LENGTH(&freq.) >0  		%THEN 
                            %DO; 
      %LET  freq2=&freq.;	
      %LET  freq_c=FREQ &freq. ;
                            %END;
 %ELSE 		%LET  freq2=1;

  %IF  %LENGTH(&weight.) >0  %THEN 	  
                                 %DO; 
               %LET     weight2=&weight.; 
               %LET    weight_c=WEIGHT &weight.;.
                               %END;
	%ELSE 	%LET  weight2=1;


ODS SELECT NONE;

*	ODS TRACE ON; 
  ODS GRAPHICS ON;

  ODS OUTPUT NObs=&lib_out.&prefix_c.NObs;
    ODS OUTPUT ModelInfo=ModelInfo;
	ODS OUTPUT ResponseProfile=&lib_out.&prefix_c.Resp_Profile;
	ODS OUTPUT ParameterEstimates=&lib_out.&prefix_c.P_Est;
	ODS OUTPUT CovB=&lib_out.&prefix_c.Cov_Est(RENAME=(Parameter=Variable));
	ODS OUTPUT IterHistory=&lib_out.&prefix_c.Iter_Parms_hist;;
*	ODS OUTPUT LoglikeChange=LoglikeChange;
*	ODS OUTPUT LastGradient=LastGradient;
	ODS OUTPUT ConvergenceStatus=&prefix_c.Convrg_Status;
*	ODS OUTPUT GoodnessOfFit=&lib_out.&prefix_c.Pearson_Dev_ChiSq;	*Comp with perfect fit. Large p-value: good model;
	*ODS OUTPUT FitStatistics=&lib_out.&prefix_c.FitStatistics;	   * Better from GENMOD;
	ODS OUTPUT RSquare=&lib_out.&prefix_c.RSquare;
	ODS OUTPUT GlobalTests=&lib_out.&prefix_c.Glob_Null_ChiSq; * Comp with intercept only model. Small p-value: good model;
	
	ODS OUTPUT Association=&lib_out.&prefix_c.Association;
   ODS OUTPUT ROCCurve=&lib_out.&prefix_c.ROCCurve;
	ODS OUTPUT LackFitPartition=&lib_out.&prefix_c.HL_Partition;
	ODS OUTPUT LackFitChiSq=&prefix_c.HL_ChiSq;
	
ODS EXCLUDE NObs OddsRatios GoodnessOfFit FitStatistics ClassLevels;

PROC LOGISTIC DATA=&reg_ds_in. DESCENDING /*PLOTS=ALL*/
							  OUTEST=&lib_out.&prefix_c.MODEL_COEFF_L
               						;  
	 MODEL	 &dependent_vars.=&independent_vars. 
													 / LINK=LOGIT  
													   RSQUARE /* Generalized RRSQUARE. Indicate predictive of the model for single events */
													  /* EXPB */ /* Exponentiates Betas. Odds ratios for logit */
													  &NOINT.
													  COVB
													   LACKFIT	 
												/* 	  SCALE=NONE	 
												       SCALE=P  */
													   OUTROC=&prefix_c.ROC
													   ITPRINT
													   STB
 													 /* FCONV=1e-4	  take precedence*/
													  XCONV=&XCONV.
													  ALPHA=&alpha.
													 MAXITER=&max_iter_nb.
												;
	 &freq_c.	 ;
	  &weight_c.;

	  	OUTPUT OUT = &prefix_c.Logit_Residuals			/* Dataset name */
             PRED= _MEAN_
			 XBETA=_XBETA_
             RESCHI = _PRESIDUAL_			      /* Pearson residials. (Y_I-\mu_I)/v_I(\mu)*/
             RESDEV = _DRESIDUAL_			/* Deviance res. */			
	  ;
RUN;
QUIT;

* ODS TRACE OFF;
  ODS GRAPHICS OFF; 

  DATA 	&lib_out.&prefix_c.Logit_Residuals;
	 SET &prefix_c.Logit_Residuals;

	IF 	&dependent_vars. NE . AND _MEAN_ NE .;

	   _FREQ_=&freq2.;
	   _WEIGHT_=&weight2.;
	 _RESP_=&dependent_vars.;
	  _RESIDUAL_=_RESP_ - _MEAN_;
      _RESIDUAL_SQ_=_RESIDUAL_ **2;
	   _ADJ_VARIANCE_=_MEAN_ * (1-_MEAN_) /_WEIGHT_;

 RUN;

    %LET resid_vars=_RESP_  _RESIDUAL_   _RESIDUAL_SQ_   _ADJ_VARIANCE_;

		%sum_by_pct2(tbl_name_in=&lib_out.&prefix_c.Logit_Residuals
			                    ,tbl_name_out= &prefix_c.resid_sum_by_pct_al
								,freq=&freq.
			                    ,x_var= _MEAN_
                                ,y_var=_RESP_  _RESIDUAL_   _RESIDUAL_SQ_   _ADJ_VARIANCE_
								,stats_for_y_vars=%STR(MEAN=  )
                                ,groups=&groups.);

		  %sum_by_pct2(tbl_name_in=&lib_out.&prefix_c.Logit_Residuals
			                    ,tbl_name_out= &prefix_c.resid_sum_by_pct_dp
								,by_var=dp_cd
								,freq=&freq.
			                    ,x_var= _MEAN_
                                ,y_var=_RESP_  _RESIDUAL_   _RESIDUAL_SQ_   _ADJ_VARIANCE_
								,stats_for_y_vars=%STR(MEAN=  )
                                ,groups=&groups.);

			DATA 	 &lib_out.&prefix_c.resid_sum_by_pct;
			LENGTH dp_cd 8;
			 SET 	  &prefix_c.resid_sum_by_pct_al
                          &prefix_c.resid_sum_by_pct_dp
				;
			RUN;

 
*ODS TRACE ON;
  *ODS GRAPHICS ON/RESET; 
 ODS SELECT NONE;
* ODS SELECT ModelFit;
 ODS OUTPUT ModelFit=&lib_out.&prefix_c.ModelFit0;  * Pears and Dev comp with perfect/saturated model. Large p-value: good model;

 *ODS OUTPUT ModelInfo=ModelInfo; 
   *ODS OUTPUT NObs=NObs;
  * ODS OUTPUT ResponseProfile=&lib_out.&prefix_c.Resp_Profile;
*  ODS OUTPUT ParameterEstimates=&lib_out.&prefix_c.P_Est; 
 *  ODS OUTPUT IterParms=&lib_out.&prefix_c.Iter_Parms; 
   * ODS OUTPUT LastGradHess=&lib_out.&prefix_c.LastGradHess;  		 
  *  ODS OUTPUT ConvergenceStatus=&lib_out.&prefix_c.Convrg_Status;  	 
  *   ODS OUTPUT CovB=&lib_out.&prefix_c.Cov_Est;;

 
	PROC GENMOD DATA=&reg_ds_in. DESCENDING /*PLOTS=ALL*/;
			  MODEL	 &dependent_vars.=&independent_vars./ DIST = B 
																						   LINK=LOGIT
																						   &NOINT.
																					    /*	SCALE=PEARSON */
																							NOSCALE	
																						     COVB
																						    ITPRINT
																					       /* CONVERGE=1E4  Default. Relative converg for parm > 0.01 otherwise  absolute */
																						  /*  INTERCEPT=&intercep_initial.
																							INITIAL=&initial_values.*/  
																						    /*EXPECTED 	*/
																							CONVERGE=&XCONV.
													  										ALPHA=&alpha.
													 										MAXITER=&max_iter_nb. 
                                                  ;

		  	 &freq_c.	 ;
	         &weight_c.;

		*	OUTPUT OUT = &prefix_c.Logit_Genmod_Residuals			/* Dataset name */
             PRED= _MEAN_
			 XBETA=_XBETA_
             RESRAW = _RESIDUAL_			/* Outputs and names raw residiuals */
             RESCHI = _PRESIDUAL_			      /* Pearson residials. (Y_I-\mu_I)/v_I(\mu)*/
             RESDEV = _DRESIDUAL_			/* Deviance res. */
			 HESSWGT=HES_WHT 				 /*Diagonal element of the weight matrix
 																			used in computing the Hessian matrix.  */
		  ;
	RUN;

	ODS SELECT ALL;

 				  *GEE;

	DATA   _reg_ds_in_;
		 SET &reg_ds_in.;
		_ids_ =_N_;
	RUN;

	ODS SELECT NONE;
 ODS SELECT GEEEmpPEst  GEERCov;
	 
	ODS OUTPUT ParmInfo=&prefix_c.Parm_Mapping;
	ODS OUTPUT  GEEEmpPEst= &lib_out.&prefix_c.P_Est_HC0(RENAME=(Parm=Variable));
*	ODS OUTPUT GEENCov=&lib_out.&prefix_c.Cov_Est_GEE;	*Model;
   	ODS OUTPUT GEERCov=&prefix_c.HC_Cov0;	  *Empirical. Sandwich estimator. Uses HC0 equivalent in PROC REG;
	   /*
	* ODS OUTPUT   GEEModInfo=GEEModInfo;
	 ODS OUTPUT ResponseProfile=&lib_out.&prefix_c.Resp_Profile;	 
	 ODS OUTPUT IterParmsGEE=&lib_out.&prefix_c.Iter_ParmsGEE;
	* ODS OUTPUT LastGEEGrad=&lib_out.&prefix_c.LastGEEGrad;
	 ODS OUTPUT GEEFitCriteria=&lib_out.&prefix_c.GEEFitCriteria; 
	*/
			 ODS EXCLUDE ClassLevels;
	PROC GENMOD DATA=_reg_ds_in_ DESCENDING /*PLOTS=ALL*/;
	 CLASS _ids_;
			  MODEL	 &dependent_vars.=&independent_vars./ DIST = B 
																						   LINK=LOGIT
																						   &NOINT.
																						   /* AGGREGATE	  */
																							/*SCALE=PEARSON	*/
																							 NOSCALE	
																						     COVB 
																						   /* ITPRINT  */
																					       /* CONVERGE=1E4  Default. Relative converg for parm > 0.01 otherwise  absolute */
																						  /*  INTERCEPT=&intercep_initial.
																							INITIAL=&initial_values.*/  
																						    /*EXPECTED 	*/
																							MAXITER=50 
                                                  ;
			REPEATED SUBJECT=_ids_/ ECOVB ; 
		  ;
		  	 &freq_c.	 ;
	         &weight_c.;
	RUN;

ODS GRAPHICS OFF; 
ODS TRACE OFF; 
  	ODS SELECT ALL;

	DATA  &prefix_c.converg_iter_nb;
         SET &lib_out.&prefix_c.Iter_Parms_hist(KEEP=Iteration)  END=last;		  
		 IF last;
	RUN;

	DATA &lib_out.&prefix_c.Convrg_Status;
	 LENGTH Status_Dsc $ 20  Reason $ 90;
	  SET &prefix_c.converg_iter_nb;
	   SET &prefix_c.Convrg_Status;

			  reg_conv_in=(Status=0);

		 Status_Dsc="Not Converged";

		   IF reg_conv_in=1  THEN Status_Dsc="Converged";
		   ELSE  Reason=CATX(" ",STRIP(Reason), "Max_iter_nb=&max_iter_nb..", " (XCONV=&xconv.)." )	;
	
		  LABEL Status_Dsc="Convergence Status";
	  RUN;

	  DATA &lib_out.&prefix_c.ModelFit;
	    SET &lib_out.&prefix_c.ModelFit0
				&lib_out.&prefix_c.RSQUARE(KEEP=Label1 nValue1 RENAME=(Label1=Criterion nValue1=Value))
				&lib_out.&prefix_c.RSQUARE(KEEP=Label2 nValue2 RENAME=(Label2=Criterion nValue2=Value))
                  ;
	
      RUN;
	
	DATA   &lib_out.&prefix_c.Parm_Mapping;
	 LENGTH VAR_NUMB_POS 8;
	  SET  &prefix_c.Parm_Mapping END=last;
	   LENGTH  str_Select0 str_Select $ 32000;
	   RETAIN  str_Select;

	   VAR_NUMB_POS=_N_;

	      IF NOT last THEN  comma=",";
		  ELSE comma=" ";
	       str_Select0=CATX(" ",Parameter,"AS",Effect);
	      str_Select=CATX(" ",str_Select, str_Select0,comma);

	   IF last THEN DO;
           CALL SYMPUT("str_Select", STRIP(str_Select)) ;
		   CALL SYMPUT("var_numb", STRIP(PUT(VAR_NUMB_POS,8.))) ;
							END;
	   DROP str_Select0 str_Select comma;
	RUN;

	%PUT str_Select=&str_Select.;
	%PUT var_numb=&var_numb.;

	PROC SQL;
     CREATE TABLE &prefix_c.HC_Cov AS 
	    SELECT 	B.Effect AS Variable
						,&str_Select.
		    FROM             &prefix_c.HC_Cov0 							AS A
			INNER JOIN  &lib_out.&prefix_c.Parm_Mapping 	 AS B
			   ON A.RowName=B.Parameter
			ORDER BY VAR_NUMB_POS
			;
		QUIT;

	   DATA  &lib_out.&prefix_c.HC_Cov;
		 SET &prefix_c.HC_Cov;
			IF _N_=1 THEN SET &lib_out.&prefix_c.NObs(KEEP=SumFreqsUsed) ;
		 ARRAY indep{*} &Intercept. &independent_vars. ;	
				 DO i=1 TO DIM(indep);
					/*Adjust to HC1 definition  in the PROC REG terminology. The GENMOD calculates using HC0 definition. */
				   indep{i}=indep{i}* (SumFreqsUsed/(SumFreqsUsed - &var_numb.)) ;
				 END;

			 DROP i SumFreqsUsed;
	 RUN;


		DATA &prefix_c.P_Est;
		  SET  &lib_out.&prefix_c.P_Est(DROP=StandardizedEst _ESTTYPE_);
			 tValue=SQRT(WaldChiSq);		
			 ProbT=2*(1-PROBNORM(abs(tValue))) ;

			      Quantile=PROBIT((1-&alpha./2));
				  LowerCL=Estimate-Quantile*StdErr;
				  UpperCL=Estimate+Quantile*StdErr;

			 DROP WaldChiSq ProbChiSq Quantile;
			 Format ProbT PVALUE6.4;
		 RUN;

		DATA  &lib_out.&prefix_c.P_Est_HC;
		LENGTH Dependent $ 32;
		 MERGE &prefix_c.P_Est
                       &lib_out.&prefix_c.P_Est_HC0(DROP=Estimate LowerCL  UpperCL Z ProbZ
																		 RENAME=( StdErr=HCStdErr )
                                                                       )
					  ;

			IF _N_=1 THEN SET &lib_out.&prefix_c.NObs(KEEP=SumFreqsUsed) ;
				/*Adjust to HC1 definition  in the PROC REG terminology. The GENMOD calculates using HC0 definition. */
			 HCStdErr=HCStdErr*SQRT(SumFreqsUsed/(SumFreqsUsed - &var_numb.));

			Dependent="&dependent_vars.";
			 HCtValue=Estimate/HCStdErr;		
			 HCProbT=2*(1-PROBNORM(abs(HCtValue))) ;

			      Quantile=PROBIT((1-&alpha./2));
				  HCLowerCL=Estimate-Quantile*HCStdErr;
				  HCUpperCL=Estimate+Quantile*HCStdErr;

			HCCMethod="HC1";
			 DROP  Quantile SumFreqsUsed;
			  Format HCtValue 7.2 HCProbT PVALUE6.4 HCLowerCL  HCUpperCL  D11.3;
		 RUN;

		DATA  _NULL_;
		   CALL SYMPUT("_cl",STRIP(PUT(100*(1.0-&alpha.),best12.)));
		   CALL SYMPUT("lib_out0",COMPRESS("&lib_out.", ". "));
		RUN;
			 
			   %PUT _cl=&_cl. lib_out0=&lib_out0.;
		  
		   PROC DATASETS LIB= &lib_out0. NOLIST;
			 MODIFY &prefix_c.P_Est_HC;
				 LABEL 
				  Estimate="Parameter Estimate"                                   
                  StdErr="Standard Error"                                         
                   tValue="t Value"                                                
                   Probt="P-Value"                                                
                   HCStdErr="Heteroscedasticity Consistent Standard Error"         
                   HCCMethod="Heteroscedasticity Consistent Covariance Method"     
                   HCTValue="Heteroscedasticity Consistent t Value"                
                   HCProbt="Heteroscedasticity Consistent P-Value"                
                   HCLowerCL="Heteroscedasticity Consistent Lower &_cl.% CL Parameter"
                   HCUpperCL="Heteroscedasticity Consistent Upper &_cl.% CL Parameter"
                   LowerCL="Lower &_cl.% CL Parameter"                                
                   UpperCL="Upper &_cl.% CL Parameter"  		
			 ;
		  RUN;

		  DATA &lib_out.&prefix_c.HL_ChiSq;
		  LENGTH dp_cd N_groups 8;
		     SET &prefix_c.HL_ChiSq;
				 dp_cd=.;
				 Test_type=1; 
				 N_groups=DF+2;
				 ValueDF=ChiSq/df;
		   RUN;

		   DATA &prefix_c.AUC_for_ROC;
               SET &lib_out.&prefix_c.Association;
			   IF Label2="c";
			    _AUC_=nValue2;
				KEEP _AUC_;
			 RUN;

			 DATA &lib_out.&prefix_c.ROC;
			    SET &prefix_c.ROC;
				 IF _N_=1 THEN SET &prefix_c.AUC_for_ROC;
		   	  RUN;

%MEND;