
  %MACRO update_tracking_tbl(updt_tbl_name_in=
                                                    ,updt_tbl_name_c_in=
												     ,updt_tbl_name_out=
													 ,tracking_tbl_out=
                                                    , file_list_txt_out=);
  /* Usage:
	%update_tracking_tbl_fl_lev(updt_tbl_name_fl_lev_in=msoc.&prefix2.track_tbl_fl_lev_updt
                                                  ,tracking_tbl_fl_lev_out=infolder.&RunID._track_tbl_fl_lev);

  /
	    /* Finalize tracking table for a given &RunID, &iter_nb, &step_nb */

	  %LOCAL updt_tbl_name_a;

  %PUT;
   %PUT -----   Start of the macro update_tracking_tbl;
   %PUT;

    %IF &iter_nb.=1 AND &step_nb.=1 %THEN 
							%DO;
	 
DATA &updt_tbl_name_out.;
	    SET &updt_tbl_name_in.; 
		  END_DTM=DATETIME();
          STEP_RETURN_CD=&step_return_cd.;
          STEP_RETURN_MSG="&step_return_msg.";	
RUN;

	 DATA &tracking_tbl_out.;
	    SET &updt_tbl_name_out.;
	  RUN;

	   PROC SORT DATA=&tracking_tbl_out.;
	    BY DP_CD MSREQID RUNID ITER_NB STEP_NB ;
	   RUN;	  

	                         %END;
	 %ELSE 
	 						  %DO;
  	
DATA &updt_tbl_name_out.;
	    SET &updt_tbl_name_in. ;

    END_DTM=DATETIME();
    REG_CONV_IN=&reg_conv_in.; 
    REG_CONV_MSG="&reg_conv_msg.";
	STEP_RETURN_CD=&step_return_cd.;
    STEP_RETURN_MSG="&step_return_msg.";
  	LAST_ITER_IN=&last_iter_in.;
    LAST_RUNID_IN=&last_runid_in.;
	utc_offset_display=substr(put('00:00:00't,E8601LZ.), 9);
    utc_offset_sec=INPUT(utc_offset_display, ?? TIME6.);		
RUN;  

%IF %LENGTH(&updt_tbl_name_c_in.) >0  %THEN  
                     %DO;
 PROC SORT DATA=&updt_tbl_name_c_in.; 
	 BY DP_CD MSREQID RUNID ITER_NB STEP_NB;
 RUN;

   PROC DATASETS NOWARN NOLIST;
      DELETE _track_tbl_updt_a;
	RUN;
	 
DATA _track_tbl_updt_a(SORTEDBY=DP_CD MSREQID RUNID ITER_NB STEP_NB)	;
   	 SET &updt_tbl_name_c_in.
			&updt_tbl_name_out.	
	   	     ;
	  BY DP_CD MSREQID RUNID ITER_NB STEP_NB;
 RUN;
	%LET updt_tbl_name_a=_track_tbl_updt_a;
		   			 %END;

   %ELSE  	%LET updt_tbl_name_a=&updt_tbl_name_out.;

 DATA &tracking_tbl_out.;
	UPDATE &tracking_tbl_out.
					&updt_tbl_name_a.(IN=INCUR)			   
		 ;
	  BY DP_CD MSREQID RUNID ITER_NB STEP_NB;
	
	   CURR_STEP_IN=(INCUR=1);
RUN;
							  %END;

	%IF %LENGTH(&file_list_txt_out.) >0 %THEN
		               %DO;	

%export_sas_to_dlm_txt(tbl_name_in=&tracking_tbl_out.
                                          ,file_name_out=&file_list_txt_out.);

				   %END;
   %PUT;
   %PUT -----   End of the macro update_tracking_tbl;
   %PUT;

  %MEND;

